#ifndef PLATFORM_H_
#define PLATFORM_H_

#define Win32

#define PLOTHISTORY

/* (Long) Integers */

#define LONG_32_BITS

/* Floating Point Arithmetic */
#undef HAVE_MATHERR		/* System V */
#define HAVE_ISNAN		/* IEEE Arith indicator */
#define HAVE_FINITE

#undef HAVE_IEEEFP_H		/* "-Wall" */
#undef HAVE_IEEE754_H		/* Linux */

#ifdef HAVE_ISNAN
#ifdef HAVE_FINITE
#define IEEE_754
#endif
#endif
extern int _isnan(double);
extern int _finite(double);
#define isnan(a) _isnan((a))
#define finite(a) _finite((a))


/* Signal Handler Type */
#define RETSIGTYPE int

/* Dynamic Linking */
#undef HAVE_DL_H		/* hpux */
#undef HAVE_DLFCN_H		/* Everything else */

/* ELF Binary Format */
#undef HAVE_ELF_H

/* Process Timing */
#define HAVE_TIMES
#undef HAVE_TIMES_H
#undef HAVE_SYS_TIMES_H

/* XDR Library Available */
#define HAVE_RPC_XDR_H

/* HDF5 Library Available */
#undef HAVE_HDF5_H

/* General String Comparison */
#undef HAVE_STRCOLL

/* Inverse Hyperbolics */
#define HAVE_ASINH
#define HAVE_ACOSH
#define HAVE_ATANH
double asinh(double);
double acosh(double);
double atanh(double);


/* Unix commands through a subshell */
#undef HAVE_SYSTEM

/* IEEE Rounding */
#undef HAVE_RINT

/* HPUX rint is broken */
#undef USE_BUILTIN_RINT

/* POSIX Regular Expressions Available */
#define HAVE_REGCOMP

/* Compatibility for "memmove" on older BSD platforms */
#undef HAVE_MEMMOVE
#undef HAVE_MEMCPY
#undef HAVE_BCOPY

/* Compatibility for setjmp / longjmp */
#undef HAVE_SIGLONGJMP

#define JMP_BUF jmp_buf
#define SETJMP(x) _setjmp(x)
#define LONGJMP(x,i) longjmp(x,i)



/* Fortran and C Links */
#define HAVE_F77_UNDERSCORE

#ifdef HAVE_F77_UNDERSCORE
#define F77_SYMBOL(x)	x ## _
#define F77_QSYMBOL(x)	#x ## "_"
#else
#define F77_SYMBOL(x)	x
#define F77_QSYMBOL(x)	#x
#endif

/* GNU Readline Library */
#undef HAVE_LIBREADLINE
#undef HAVE_READLINE_HISTORY_H

#undef HAVE_LOCALE_H
#undef HAVE_UNISTD_H

/* Bug Workarounds */
#undef HAVE_OSF_SPRINTF_BUG

/* Some platforms other than ELF drop the leading _ */
#undef HAVE_NO_SYMBOL_UNDERSCORE
#ifndef HAVE_NO_SYMBOL_UNDERSCORE
#ifdef HAVE_ELF_H
#define HAVE_NO_SYMBOL_UNDERSCORE
#endif
#endif

/* SunOS 4 is famous for broken header files */
#undef SunOS4
#ifdef SunOS4
# ifndef NULL
#  define	NULL		0
# endif
# ifndef RAND_MAX
#  define	RAND_MAX	32767
# endif
#endif /* SunOS4 */

#ifdef Win32
#define OSTYPE      "Win32"
#define FILESEP     "/"
#define DYNLOADEXT  ".dll"
#endif

/* Printing Command */
#define R_PRINTCMD	""

#define R_PLATFORM	"Windows"
#define R_CPU		"x86"
#define R_VENDOR	"IBM"
#define R_OS		"Win32"
#define R_MAJOR		"0"
#define R_MINOR		"64.0"
#define R_STATUS	"Patched"
#define R_STATUS_REV	"0"
#define R_DAY		"5"
#define R_MONTH		"May"
#define R_YEAR		"1999"


#ifndef M_PI
#define M_PI		3.141592653589793238462643383279502884197169399375
#endif
#define	M_1_PI		0.31830988618379067154	/* 1/pi */
#define	M_PI_2		1.57079632679489661923	/* pi/2 */
#define	M_LOG10E	0.43429448190325182765	/* log 10e */
#define M_SQRT_2        1.41421356237309504880  /* sqrt(2) */

#ifndef max
#define max(a,b)	(((a)>(b))?(a):(b))
#define min(a,b)	(((a)<(b))?(a):(b))
#endif
/* P.D. */
#define erf(x) 2*pnorm((x)*M_SQRT_2,0,1)-1
#define erfc(x) 2*pnorm(-(x)*M_SQRT_2,0,1)
#define gamma(x) gammafn(x)
#define lgamma(x) lgammafn(x)



#endif
